#ifdef WIN32
#pragma warning (disable : 4786)
#endif

// C++ Includes
#include <iostream>

// Local Includes
#include <ctpp/ctpp.hpp>
int main(void)
{
	using namespace template_parser_ns;
	using namespace std;

	//   
	param_data * pData = new param_data(param_data::HASH);
	//   
	pData -> hash_insert_new_var("global_param", "Global Parameter");

	//  
	param_data * pArray = pData -> hash_insert_new_array("EMPLOYEE_INFO");

	//   -   
	param_data * pHash = pArray -> array_insert_new_hash();
	//  "NAME"
	pHash -> hash_insert_new_var("NAME", " ");
	//  "JOB"
	pHash -> hash_insert_new_var("JOB", "");

	pHash = pArray -> array_insert_new_hash();
	pHash -> hash_insert_new_var("NAME", " ");
	pHash -> hash_insert_new_var("JOB", "");
	//   
	pHash -> hash_insert_new_var("global_param", "Replaced Parameter");

	try
	{
		// 
		template_text oTemplate;

		//  
		loader_base * pLoaderBase = new loader_base();

		//   
		v_include_dir vIncludeDir;
		vIncludeDir.push_back("./tmpl");
		oTemplate.set_include_dir(vIncludeDir);
		//  
		pLoaderBase -> load_file("./tmpl/3_1.tmpl");
		//  
		oTemplate.parse(pLoaderBase -> get_data());
		//    
		oTemplate.param(pData);
		string sOutput;
		//  
		sOutput.assign(oTemplate.output());
		cout << sOutput << endl;
	}
	catch(exception &e) { cout << e.what() << endl; exit(1); }
return 0;
}
